# -*- coding: utf-8 -*-

from model.Study import Study
from view.ASubWindow import ASubWindow

class NewStudyWindow(ASubWindow):
    def __init__(self, study=None, title="New Study", parent=None):
        super(NewStudyWindow, self).__init__(name=title, ui="NewStudy", parent=parent)
        self.ui.setWindowTitle(title)

        self.parent = parent

        self.study = study

        if not self.study is None:
            self.set_line_edit_text("lineEdit_name", study.name)
            self.set_text_edit_text("textEdit_description", study.description)

    def accept(self):
        name = self.get_line_edit_text("lineEdit_name")
        description = self.get_text_edit_text("textEdit_description")

        if self.study is None:
            self.parent.set_model(Study.new(name, description))
        else:
            self.study.name = name
            self.study.description = description
        self.done(True)
